/** semplice prodotto matrice matrice   **/
/** Giorgio Amati, CASPUR, 2006-2012   **/
/** Francesco Salvadore , CASPUR, 2006-2012    **/
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#define nn (512)
int TESTS_QUIET = 0;

#include "inc_precision.h"
#ifdef PAPI
#include "papi_test.h"
#endif

REAL a[nn][nn];       /** matrici**/
REAL b[nn][nn];
REAL c[nn][nn];

#ifdef PAPI
      int retval,num_events;
      long long  values[100];
      int events[100];
#endif


int main()
{
  int k, i, j, ii, jj;
  REAL somma;
  float time1, time2, dub_time;

#ifdef PAPI
#ifdef CACHE
    events[0] = PAPI_L2_TCA; 
    events[1] = PAPI_L2_TCM;  
    events[2] = PAPI_L3_TCA; 
    events[3] = PAPI_L3_TCM;  
#else
    events[0] = PAPI_DP_OPS;
    events[1] = PAPI_TOT_CYC; 
#endif
#endif

  printf("===============================\n");
  if(sizeof(a[1][1]) == sizeof(float))
    printf("prodotto di matrici in singola precisione\n");
  else
    printf("prodotto di matrici in doppia precisione\n");
  printf("dimensioni %d \n",nn );
  printf("===============================\n");
  printf("Inizializzazione \n");

  /* initialize matrix */
  time1 = clock();
  for (j = 0; j < nn; j++)
    {
    for (i = 0; i < nn; i++)
      {
      a[j][i] = ((REAL)rand())/((REAL)RAND_MAX);
      b[j][i] = ((REAL)rand())/((REAL)RAND_MAX);
      c[j][i] = 0.0L;		
      }
    }
  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("Tempo impiegato per inizializzare \n");
  printf("Tempo -----------------> %f \n", dub_time);
#ifdef PAPI
#ifdef CACHE
    num_events = 4;
#else
    num_events = 2;
#endif
   retval = PAPI_start_counters( events, num_events );
    printf( "start: %d\n", retval );
#endif

  time1 = clock();
/*  qui sotto va completato il programma, prodotto righe per colonne */
/*  c_ij = c_ij + a_ik * b_kj                                  */ 
  for (k = 0; k < nn; k ++)
       for (j = 0; j < nn; j++)
            for (i = 0; i < nn; i++)
                 c[i][j] = c[i][j] + a[i][k]*b[k][j];


/*  qui sopra va completato il programma, prodotto righe per colonne */
#ifdef PAPI
     retval = PAPI_stop_counters( values, num_events );
    printf( "stop: %d\n", retval );
#endif
     
  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("===============================\n");
  printf("Tempo per prodotto classico \n");
  printf("Tempo -----------------> %f \n", dub_time);
  printf("Mflops ----------------> %f \n", 
          2.0*nn*nn*nn/(1000*1000*dub_time));
#ifdef PAPI
#ifdef CACHE
   printf( TAB1,   " PAPI_L2_TCA:            ", values[0] );
   printf( TAB1,   " PAPI_L2_TCM:          " , values[1] );
   printf( TAB1,   " PAPI_L3_TCA:          " , values[2] );
   printf( TAB1,   " PAPI_L3_TCM:          " , values[3] ); 
  printf("L2 percentuale di cache miss-----------------> %f \n", 100*((float)values[1]/(float)values[0]));
  printf("L3 percentuale di cache miss-----------------> %f \n", 100*((float)values[3]/(float)values[2]));
#else
   printf( TAB1,   " PAPI_DP_OPS:            ", values[0] );
   printf("PAPI FOAT-POINTS-OP %f \n", (float)values[0]/(time2-time1));
   printf( TAB1,   " PAPI_TOT_CYC:          " , values[1] );
   printf("Numero di operazioni medie per ciclo-----------------> %f \n", (float)values[0]/(float)values[1]);
#endif
#endif

  /* semplice controllo */
  somma = 0.0L;
  for (i = 0; i < nn; i++)
     for (j = 0; j < nn; j++)
         somma = somma + c[i][j];
  printf("Controllo -------------> %f \n", somma);

   return 0;  
}
