/** semplice prodotto matrice matrice   **/
/** Giorgio Amati, CASPUR, 2006-2012   **/
/** Francesco Salvadore , CASPUR, 2006-2012    **/
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#define nn (1024)
#define step (256)
#define npad (9)

#include "inc_precision.h"

REAL a[nn+npad][nn+npad];       /** matrici**/
REAL b[nn+npad][nn+npad];
REAL c[nn+npad][nn+npad];

int main()
{
  int k, i, j, ii, jj, kk;
  REAL somma;
  float time1, time2, dub_time;

  printf("===============================\n");
  if(sizeof(a[1][1]) == sizeof(float))
    printf("prodotto di matrici in singola precisione\n");
  else
    printf("prodotto di matrici in doppia precisione\n");
  printf("dimensioni %d \n",nn );
  printf("blocking   %d \n",step );
  printf("===============================\n");
  printf("Inizializzazione \n");

  /* initialize matrix */
  time1 = clock();
  for (j = 0; j < nn; j++)
    {
    for (i = 0; i < nn; i++)
      {
      a[j][i] = ((REAL)rand())/((REAL)RAND_MAX);
      b[j][i] = ((REAL)rand())/((REAL)RAND_MAX);
      c[j][i] = 0.0L;		
      }
    }
  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("Tempo impiegato per inizializzare \n");
  printf("Tempo -----------------> %f \n", dub_time);

  time1 = clock();
/*  prodotto righe per colonne 					*/
/*  c_ij = c_ij + a_ik * b_kj                                  	*/ 
  for (ii = 0; ii < nn; ii= ii+step)
     for (kk = 0; kk < nn; kk = kk+step)
        for (jj = 0; jj < nn; jj = jj+step)
           for (i = ii; i < ii+step; i++)
              for (k = kk; k < kk+step; k++)
                 for (j = jj; j < jj+step; j++)
                    c[i][j] = c[i][j] + a[i][k]*b[k][j];
  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("===============================\n");
  printf("Tempo per prodotto classico \n");
  printf("Tempo -----------------> %f \n", dub_time);
  printf("Mflops ----------------> %f \n", 
          2.0*nn*nn*nn/(1000*1000*dub_time));

  /* semplice controllo */
  somma = 0.0L;
  for (i = 0; i < nn; i++)
     for (j = 0; j < nn; j++)
         somma = somma + c[i][j];
  printf("Controllo -------------> %f \n", somma);

   return 0;  
}
