/** semplice prodotto matrice matrice   **/
/** Giorgio Amati, CASPUR, 2006-2012   **/
/** Francesco Salvadore , CASPUR, 2006-2012    **/
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#define nn (1024)
#define npad (9)

#include "inc_precision.h"

REAL a[nn][nn+npad];       /** matrici**/
REAL b[nn][nn+npad];
REAL c[nn][nn+npad];

int main()
{
  int k, i, j, ii, jj, kk;
  REAL somma;
  float time1, time2, dub_time;

  printf("===============================\n");
  if(sizeof(a[1][1]) == sizeof(float))
    printf("prodotto di matrici in singola precisione\n");
  else
    printf("prodotto di matrici in doppia precisione\n");
  printf("dimensioni %d \n",nn );
  printf("padding    %d \n",npad );
  printf("===============================\n");
  printf("Inizializzazione \n");


  /* initialize matrix */
  time1 = clock();
  for (j = 0; j < nn; j++)
    {
    for (i = 0; i < nn; i++)
      {
      a[j][i] = ((REAL)rand())/((REAL)RAND_MAX);
      b[j][i] = ((REAL)rand())/((REAL)RAND_MAX);
      c[j][i] = 0.0L;		
      }
    }
  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("Tempo impiegato per inizializzare \n");
  printf("Tempo -----------------> %f \n", dub_time);

  time1 = clock();
/*  prodotto righe per colonne 					*/
/*  c_ij = c_ij + a_ik * b_kj                                  	*/ 
/*  for (i = 0; i < nn; i+=16) */
  for (i = 0; i < nn; i+=16)
     for (k = 0; k < nn; k++)
        for (j = 0; j < nn; j++) {
              c[i+ 0][j] = c[i+ 0][j] + a[i+ 0][k]*b[k][j];
              c[i+ 1][j] = c[i+ 1][j] + a[i+ 1][k]*b[k][j];
              c[i+ 2][j] = c[i+ 2][j] + a[i+ 2][k]*b[k][j];
              c[i+ 3][j] = c[i+ 3][j] + a[i+ 3][k]*b[k][j];
              c[i+ 4][j] = c[i+ 4][j] + a[i+ 4][k]*b[k][j];
              c[i+ 5][j] = c[i+ 5][j] + a[i+ 5][k]*b[k][j];
              c[i+ 6][j] = c[i+ 6][j] + a[i+ 6][k]*b[k][j];
              c[i+ 7][j] = c[i+ 7][j] + a[i+ 7][k]*b[k][j];
              c[i+ 8][j] = c[i+ 8][j] + a[i+ 8][k]*b[k][j];
              c[i+ 9][j] = c[i+ 9][j] + a[i+ 9][k]*b[k][j];
              c[i+10][j] = c[i+10][j] + a[i+10][k]*b[k][j];
              c[i+11][j] = c[i+11][j] + a[i+11][k]*b[k][j];
              c[i+12][j] = c[i+12][j] + a[i+12][k]*b[k][j];
              c[i+13][j] = c[i+13][j] + a[i+13][k]*b[k][j];
              c[i+14][j] = c[i+14][j] + a[i+14][k]*b[k][j];
              c[i+15][j] = c[i+15][j] + a[i+15][k]*b[k][j]; 
      }
  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("===============================\n");
  printf("Tempo per prodotto classico \n");
  printf("Tempo -----------------> %f \n", dub_time);
  printf("Mflops ----------------> %f \n", 
          2.0*nn*nn*nn/(1000*1000*dub_time));

  /* semplice controllo */
  somma = 0.0L;
  for (i = 0; i < nn; i++)
     for (j = 0; j < nn; j++)
         somma = somma + c[i][j];
  printf("Controllo -------------> %f \n", somma);

   return 0;  
}
