/** semplice prodotto matrice matrice   **/
/** Giorgio Amati, CASPUR, 2006-2012   **/
/** Francesco Salvadore , CASPUR, 2006-2012    **/
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#define nn (2048)

//CBLAS #include "mkl.h"

#include "inc_precision.h"

REAL a[nn][nn];       /** matrici**/
REAL b[nn][nn];
REAL c[nn][nn];

int main()
{
  int k, i, j, ii, jj, kk;
  REAL somma;
  float time1, time2, dub_time;
  int n_var = nn;
  REAL one = 1.0; REAL zero = 0.0;
  char trans = 'T'; 

  printf("===============================\n");
  if(sizeof(a[1][1]) == sizeof(float))
    printf("prodotto di matrici in singola precisione usando BLAS\n");
  else
    printf("prodotto di matrici in doppia precisione usando BLAS\n");
  printf("dimensioni %d \n",nn );
  printf("===============================\n");
  printf("Inizializzazione \n");

  /* initialize matrix */
  time1 = clock();
  for (j = 0; j < nn; j++)
    {
    for (i = 0; i < nn; i++)
      {
      a[j][i] = ((REAL)rand())/((REAL)RAND_MAX);
      b[j][i] = ((REAL)rand())/((REAL)RAND_MAX);
      c[j][i] = 0.0L;		
      }
    }
  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("Tempo impiegato per inizializzare \n");
  printf("Tempo -----------------> %f \n", dub_time);

  time1 = clock();
/*  prodotto righe per colonne 					*/
/*  c_ij = c_ij + a_ik * b_kj                                  	*/ 
#ifdef SINGLEPRECISION
  sgemm_(&trans,&trans,&n_var,&n_var,&n_var,&one,(float*)a,&n_var,(float*)b,&n_var,&zero,(float*)c,&n_var);
//CBLAS  cblas_sgemm(CblasRowMajor,CblasNoTrans, CblasNoTrans,n_var,n_var,n_var,one,(float*)a,n_var,(float*)b,n_var,zero,(float*)c,n_var);
#else
  dgemm_(&trans,&trans,&n_var,&n_var,&n_var,&one,(double*)a,&n_var,(double*)b,&n_var,&zero,(double*)c,&n_var);
//CBLAS  cblas_dgemm(CblasRowMajor,CblasNoTrans, CblasNoTrans,n_var,n_var,n_var,one,(double*)a,n_var,(double*)b,n_var,zero,(double*)c,n_var);
#endif

  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("===============================\n");
  printf("Tempo per prodotto classico \n");
  printf("Tempo -----------------> %f \n", dub_time);
  printf("Mflops ----------------> %f \n", 
          2.0*nn*nn*nn/(1000*1000*dub_time));

  /* semplice controllo */
  somma = 0.0L;
  for (i = 0; i < nn; i++)
     for (j = 0; j < nn; j++)
         somma = somma + c[j][i];
  printf("Controllo -------------> %f \n", somma);

   return 0;  
}
