program mm
!
!       (c) 2002/2012 by CASPUR/G.Amati,F.Salvadore
!
    use precision_module
    use timing_module
       
    implicit none
!
    integer i,j,k ! index
    integer, parameter :: n=4000            ! size of the matrix
!
    real(my_kind) a(1:n,1:n) ! matrix
    real(my_kind) b(1:n,1:n) ! matrix
    real(my_kind) c(1:n,1:n) ! matrix (destination)
    real(my_kind) d(1:n,1:n) ! matrix (destination)
    real(my_kind) time1, time2 ! timing
    real(my_kind) :: mflops, bandwidth,aa
    REAL(KIND=8),EXTERNAL :: DDOT
!
    mflops = 2*float(n)*float(n)*float(n)/(1000.0_my_kind*1000.0_my_kind)
    bandwidth = 3*my_kind*float(N)*float(N)/(1024*1024)
!
    call timing(time1)
    call random_number(a)
    call random_number(b)
    c = 0._my_kind 
    d = 0._my_kind 
    call timing(time2)
    write(*,*) "--------------------------------------"
    write(*,*) " Matrix-Matrix Multiplication using BLAS        "
    write(*,*) " Calcolo con precisione: ",precision(a(1,1))
    write(*,*) " rel. 0, naive multiplication         "
    write(*,*) " size =", n                      
    write(*,*) "--------------------------------------"
    write(*,*) "initialization", time2-time1
    write(*,*) a(n/2,n/2),b(n/2,n/2),c(n/2,n/2)
!
! main loop
!

#ifdef VIC
    call timing(time1)
        do i=1,N
           do j=1,N
!           write(*,*) DDOT(N,a(i,:),1,b(:,j),1)
           aa=ddot(N,a(i,:),1,b(:,j),1)
           end do
          end do
    call timing(time2)
    print*, "time for DDOT", time2-time1

    call timing(time1)
           do j=1,N
            call DGEMV('n',N,N,1.d0,a,N,b(:,j),1,0.d0,d,1)
           end do
    call timing(time2)
    print*, "time for DGEMV", time2-time1
#endif
    call timing(time1)
!
!  qui sotto va completato il programma, prodotto righe per colonne
!   c_ij = c_ij + a_ik * b_kj     
!
#ifdef SINGLEPRECISION
    call SGEMM('n','n',N,N,N,1.0,a,N,b,N,0.0,c,N)
#else
    call DGEMM('n','n',N,N,N,1.d0,a,N,b,N,0.d0,c,N)
#endif
!
!  qui sopra va completato il programma, prodotto righe per colonne
!
    call timing(time2)
    print*, "--------------------------------------"
    print*, "time for moltiplication", time2-time1
    print*, "Mflops                 ", mflops/(time2-time1)
    print*, 'bandwidth :  ', bandwidth/(time2-time1)
    print*, "--------------------------------------"
    print*, "       "
    print*, "       "
    print*, a(n/2,n/2),b(n/2,n/2),c(n/2,n/2)
!
end program mm

